var SINGLETON_SYSTEM_ALERTS = {};

// Creates and returns a hidden system alert or null if creation failed.
// text: HTML message
// type: primary, secondary, success, danger, warning, info (default), light, dark
// id: optional.  Instead of using the default counter value, you can give your id.
// singleton: optional boolean.  If true, only create this alert the first time and return null every other time.
function SystemAlert(parent, text, type, id, singleton) {
    if (typeof SystemAlert.count == 'undefined') {
        SystemAlert.count = 0;
    }

    this.__parent = parent;

    this.__id = id;
    if (this.__id === undefined || this.__id === null) {
        SystemAlert.count += 1;
        this.__id = "system-alert-" + SystemAlert.count;
    }

    this.__type = type
    if (this.__type === undefined || this.__type === null) {
        this.__type = "info"
    }

    this.__text = text;
    this.__template =
        '<div id="' + this.__id + '" class="system-alert alert alert-' + this.__type + ' fade in collapse">' +
        '  <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>' +
        '  <span class="glyphicon glyphicon-info-sign"></span>' +
        '  ' + this.__text +
        '</div>';

    if (singleton === true) {
        if (SINGLETON_SYSTEM_ALERTS[this.__id] === true) {
            return null;
        } else {
            SINGLETON_SYSTEM_ALERTS[this.__id] = true;
        }
    }

    $("#" + this.__id).remove();
    $(this.__parent).append(this.__template);
    return $("#" + this.__id);
}

function closeSystemAlert(id) {
    $(id).alert("close");
}

function setAutoHideSystemAlert(id, ms) {
    setTimeout(closeSystemAlert, ms, id);
}

