var htmlEncode = function(html) {
    return html.replace(/[&"'\<\>\/]/g, function(c) {
        switch (c) {
            case "&":
                return "&amp;";
            case "\"":
                return "&quot;";
            case "'":
                return "&#39;";
            case "<":
                return "&lt;";
            case ">":
                return "&gt;";
            case "/":
                return "&#x2F;";
        }
    });
};

var translate = function(s, oldChar, newChar) {
    return s.split(oldChar).join(newChar);
};

var disableTransparency = function() {
    $("canvas").removeClass("transparent-background");
    $("body").removeClass("transparent-background");
};

Number.isInteger = Number.isInteger || function(value) {
    return typeof value === "number" && isFinite(value) && Math.floor(value) === value;
};

String.prototype.replaceAll = function(search, replacement) {
    var target = this;
    return target.replace(new RegExp(search, 'g'), replacement);
};

function applicationExpiredWarning() {
    alert("Thanks for trying out Scyld Cloud Workstation!  This trial release has expired.  " +
          "Contact Penguin Computing for information about purchasing Scyld Cloud Workstation.");
}

function copyToClipboard(element) {
    $(element).trigger("select");
    document.execCommand("copy");
}

// Give something focus and return to the previous scroll place
$.fn.focusNoScroll = function() {
    /* if we're using the native scrollbar */
    if (typeof myScrollbars === "undefined") {
        var x = window.pageXOffset, y = window.pageYOffset;
        this.trigger("focus");
        window.scrollTo(x, y);
    } else {
        var s = myScrollbars.scroll();
        var x = s.x.position, y = s.y.position;
        $(this).css({left: x, top: y});
        this.trigger("focus");
    }
};

// Buttons that have a data-hide="<class>" attribute will close all elements with the given "class".
// NOTE: Only guaranteed to work on statically defined HTML elements.
$(function() {
    $("[data-hide]").on("click", function() {
        $("." + $(this).attr("data-hide")).hide();
        // -or-, see below
        // $(this).closest("." + $(this).attr("data-hide")).hide();
    });
});
